# Ipopt::SchurDriver Class Reference

`#include <SensSchurDriver.hpp>`

Inheritance diagram for Ipopt::SchurDriver:
[legend]

List of all members.

## Public Member Functions
| SchurDriver (SmartPtr< PCalculator > pcalc, SmartPtr< SchurData > data_B)
| This class is the interface for any class that deals with the Schur matrix from the point when it is constructed by the PCalculator to the solution against one vector.
virtual | ~SchurDriver ()
virtual bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| Overloaded from AlgorithmStrategyObject.
virtual SmartPtr< const SchurData > | data_A () const
| Const accessor methods to the SchurData for for the derived classes.
virtual SmartPtr< const SchurData > | data_B () const
virtual SmartPtr< SchurData > | data_A_nonconst ()
virtual SmartPtr< SchurData > | data_B_nonconst ()
virtual SmartPtr< const PCalculator > | pcalc () const
virtual SmartPtr< PCalculator > | pcalc_nonconst ()
virtual bool | SchurBuild ()=0
| Sets the Data for which this SchurMatrix will be built.
virtual bool | SchurFactorize ()=0
| Calls the factorization routine for the SchurMatrix.
virtual bool | SchurSolve (SmartPtr< IteratesVector > lhs, SmartPtr< const IteratesVector > rhs, SmartPtr< Vector > delta_u, SmartPtr< IteratesVector > sol=NULL)=0
| Performs a backsolve on S and K.
## Private Member Functions
| SchurDriver ()
| Performs a backsolve on S and K; calls the latter with sol=K^(-1)*r_s=0 virtual bool SchurSolve(SmartPtr<IteratesVector> lhs, SmartPtr<const IteratesVector> rhs, SmartPtr<Vector> delta_u) =0;.
## Private Attributes
SmartPtr< PCalculator > | pcalc_
SmartPtr< SchurData > | data_B_

## Detailed Description

Definition at line 18 of file SensSchurDriver.hpp.

## Constructor & Destructor Documentation

Ipopt::SchurDriver::SchurDriver | ( | SmartPtr< PCalculator > | pcalc,
|  | SmartPtr< SchurData > | data_B |
| ) |  |  | `[inline]`

This class is the interface for any class that deals with the Schur matrix from the point when it is constructed by the PCalculator to the solution against one vector.

Specific implementations may also incorporate the treatment of adding rows/cols (like QPSchur).

The computations done by this class are 1. Solve 2. Solve (really?)

Definition at line 31 of file SensSchurDriver.hpp.

virtual Ipopt::SchurDriver::~SchurDriver | ( |  | ) | `[inline, virtual]`

Definition at line 39 of file SensSchurDriver.hpp.

Ipopt::SchurDriver::SchurDriver | ( |  | ) | `[inline, private]`

Performs a backsolve on S and K; calls the latter with sol=K^(-1)*r_s=0 virtual bool SchurSolve(SmartPtr<IteratesVector> lhs, SmartPtr<const IteratesVector> rhs, SmartPtr<Vector> delta_u) =0;.

Definition at line 102 of file SensSchurDriver.hpp.

## Member Function Documentation

virtual bool Ipopt::SchurDriver::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[inline, virtual]`

Overloaded from AlgorithmStrategyObject.

Implements Ipopt::AlgorithmStrategyObject.

Definition at line 44 of file SensSchurDriver.hpp.

virtual SmartPtr<const SchurData> Ipopt::SchurDriver::data_A | ( |  | ) | const`[inline, virtual]`

Const accessor methods to the SchurData for for the derived classes.

Definition at line 51 of file SensSchurDriver.hpp.

virtual SmartPtr<const SchurData> Ipopt::SchurDriver::data_B | ( |  | ) | const`[inline, virtual]`

Definition at line 56 of file SensSchurDriver.hpp.

virtual SmartPtr<SchurData> Ipopt::SchurDriver::data_A_nonconst | ( |  | ) | `[inline, virtual]`

Definition at line 61 of file SensSchurDriver.hpp.

virtual SmartPtr<SchurData> Ipopt::SchurDriver::data_B_nonconst | ( |  | ) | `[inline, virtual]`

Definition at line 66 of file SensSchurDriver.hpp.

virtual SmartPtr<const PCalculator> Ipopt::SchurDriver::pcalc | ( |  | ) | const`[inline, virtual]`

Definition at line 71 of file SensSchurDriver.hpp.

virtual SmartPtr<PCalculator> Ipopt::SchurDriver::pcalc_nonconst | ( |  | ) | `[inline, virtual]`

Definition at line 76 of file SensSchurDriver.hpp.

virtual bool Ipopt::SchurDriver::SchurBuild | ( |  | ) | `[pure virtual]`

Sets the Data for which this SchurMatrix will be built.

Creates the SchurMatrix from B and P

Implemented in Ipopt::DenseGenSchurDriver.

virtual bool Ipopt::SchurDriver::SchurFactorize | ( |  | ) | `[pure virtual]`

Calls the factorization routine for the SchurMatrix.

Implemented in Ipopt::DenseGenSchurDriver.

virtual bool Ipopt::SchurDriver::SchurSolve | ( | SmartPtr< IteratesVector > | lhs,
|  | SmartPtr< const IteratesVector > | rhs,
|  | SmartPtr< Vector > | delta_u,
|  | SmartPtr< IteratesVector > | sol = `NULL` |
| ) |  |  | `[pure virtual]`

Performs a backsolve on S and K.

Implemented in Ipopt::DenseGenSchurDriver.

## Member Data Documentation

SmartPtr<PCalculator> Ipopt::SchurDriver::pcalc_`[private]`

Definition at line 106 of file SensSchurDriver.hpp.

SmartPtr<SchurData> Ipopt::SchurDriver::data_B_`[private]`

Definition at line 108 of file SensSchurDriver.hpp.

The documentation for this class was generated from the following file:

- contrib/sIPOPT/src/SensSchurDriver.hpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines